using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace forums
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			 

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 16);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(520, 304);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 342);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.TableModel.Options.WrapCellBehavior = GridWrapCellBehavior.WrapRow;
			
			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();
		

			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable});

			DataRelation parentToChild = new DataRelation("ParentToChild", parentTable.Columns["parentID"], childTable.Columns["ParentID"]);
			ds.Relations.AddRange(new DataRelation[]{parentToChild});

			this.gridGroupingControl1.DataSource = parentTable;
			this.gridGroupingControl1.TableModel.Cols.FreezeRange(0,1);    

//			this.gridGroupingControl1.TableControl.HScrollPixel = true;
//			this.gridGroupingControl1.TableControl.VScrollPixel = true;
  
			this.gridGroupingControl1.TableControl.HScrollPixelPosChanged +=new GridScrollPositionChangedEventHandler(tc_HScrollPixelPosChanged);
			//this.gridGroupingControl1.TableDescriptor.Columns["Date"].Appearance.AnyCell.ShowButtons = GridShowButtons.Hide;      
		}

		#region DataTables

		private int numberParentRows = 5;
		private int numberChildRows = 20;
		
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));
			

			for(int i = 0;i < 5;i++)
				dt.Columns.Add();  
			dt.Columns.Add(new DataColumn("Date",typeof(DateTime)));
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				for(int j = 3;j < 7;j++)
				{
					dr[j] = "Column" + j;
				}
				dr[8] = DateTime.Now; 
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			dt.Columns.Add(new DataColumn("other")); //upper case P
			dt.Columns.Add(new DataColumn("otherx")); //upper case P
			for(int i = 0;i < 5;i++)
				dt.Columns.Add(); 
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dr[3] = string.Format("other{0}",i);
				dr[4] = string.Format("otherx{0}",i);

				for(int j = 5;j < 9;j++)
				{
					dr[j] = "Column" + j;
				}
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		
		#endregion

		private void tc_HScrollPixelPosChanged(object sender, GridScrollPositionChangedEventArgs e)
		{
			GridTableControl tc =  this.gridGroupingControl1.GetTableControl("ChildTable"); 
			tc.RefreshRange(GridRangeInfo.Cols(2,2));  
		 
		}

		
	}
}
